"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.startAt = exports.wechaty = exports.template = exports.callLimiter = exports.sqliteTemplate = exports.__src_dir = exports.__build_dir = exports.__interceptor_dir = exports.__data_dir = void 0;
require("./better-console");
const wechaty_1 = require("wechaty");
const qrcode_terminal_1 = __importDefault(require("qrcode-terminal"));
const path_1 = __importDefault(require("path"));
const Util_1 = require("./lib/Util");
exports.__data_dir = path_1.default.join(__dirname, "../data");
exports.__interceptor_dir = path_1.default.join(__dirname, "./interceptor");
exports.__build_dir = __dirname;
exports.__src_dir = path_1.default.join(__dirname, "../src");
Util_1.mkdirSync(exports.__data_dir);
const SqliteTemplate_1 = __importDefault(require("./lib/SqliteTemplate"));
const sqliteTemplate = new SqliteTemplate_1.default(path_1.default.join(exports.__data_dir, "./database.db"));
exports.sqliteTemplate = sqliteTemplate;
const CallLimiter_1 = __importDefault(require("./lib/CallLimiter"));
const callLimiter = new CallLimiter_1.default(sqliteTemplate);
exports.callLimiter = callLimiter;
const Template_1 = __importDefault(require("./lib/Template"));
const template = new Template_1.default();
exports.template = template;
// 给公共模板设置默认值
require("./template");
// 启动http服务器
const server_1 = __importDefault(require("./server"));
server_1.default();
// 引入拦截器
const interceptor_1 = require("./interceptor");
const wechaty = wechaty_1.Wechaty.instance({
    name: "PiggyBro"
});
exports.wechaty = wechaty;
wechaty.on("scan", (qrcode, status) => {
    switch (status) {
        case 2:
            console.log(template.use("on.scan.link"));
            console.log(`https://wechaty.js.org/qrcode/${encodeURIComponent(qrcode)}`);
            // 生成二维码打印在屏幕上
            qrcode_terminal_1.default.generate(qrcode, function (output) {
                console.log(template.use("on.scan.terminal", {
                    qrcode: output
                }));
            });
            break;
        case 3:
            console.log(template.use("on.scan.confirm"));
            break;
        case 4:
            console.log(template.use("on.scan.login"));
            break;
        default:
            console.log(status, qrcode);
    }
});
wechaty.on("login", (user) => {
    console.log(template.use("on.login", {
        name: `\x1B[43m${user.name()}\x1b[0m`
    }));
});
wechaty.on("logout", (user) => {
    console.log(template.use("on.logout", {
        name: `\x1B[43m${user.name()}\x1b[0m`
    }));
});
wechaty.on("message", (message) => __awaiter(void 0, void 0, void 0, function* () {
    if (message.self())
        return;
    yield interceptor_1.mp.process(message);
}));
wechaty.on("error", (error) => __awaiter(void 0, void 0, void 0, function* () {
    console.error(template.use("on.error"));
    console.error(error);
}));
wechaty.start().then(() => {
    console.log(template.use("on.start"));
});
const startAt = new Date();
exports.startAt = startAt;
