"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// 入口是守护程序，目的是让bot在意外结束时不至于直接被关闭
// 同时也支持运行多个bot实例
const child_process_1 = __importDefault(require("child_process"));
const path_1 = __importDefault(require("path"));
require("./better-console");
function createBot() {
    const botProcess = child_process_1.default.fork(path_1.default.join(__dirname, "./bot"));
    botProcess.on("exit", function (code) {
        console.log("机器人进程已退出，退出码：" + code);
        if (code !== 0) {
            console.log("正在重新启动……");
            createBot();
        }
    });
    botProcess.on("error", function (e) {
        console.log("机器人进程发生错误：" + e);
        console.log("正在重新启动……");
        createBot();
    });
}
createBot();
