"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Interceptor_name, _Interceptor_registHandler, _Interceptor_title, _Interceptor_alias, _Interceptor_check, _Interceptor_handler, _Interceptor_usage, _Interceptor_attributes;
Object.defineProperty(exports, "__esModule", { value: true });
class Interceptor {
    constructor(name, registHandler = () => void 0) {
        _Interceptor_name.set(this, void 0);
        _Interceptor_registHandler.set(this, void 0);
        _Interceptor_title.set(this, void 0);
        _Interceptor_alias.set(this, []);
        _Interceptor_check.set(this, []);
        _Interceptor_handler.set(this, []);
        _Interceptor_usage.set(this, void 0);
        _Interceptor_attributes.set(this, {});
        if (name.match(/\s/))
            throw new Error(`Cannot create interceptor: name cannot includes space: ${name}`);
        __classPrivateFieldSet(this, _Interceptor_name, name, "f");
        __classPrivateFieldSet(this, _Interceptor_registHandler, registHandler, "f");
        return this;
    }
    get $name() {
        return __classPrivateFieldGet(this, _Interceptor_name, "f");
    }
    get $regist() {
        return __classPrivateFieldGet(this, _Interceptor_registHandler, "f");
    }
    get $title() {
        return __classPrivateFieldGet(this, _Interceptor_title, "f") || __classPrivateFieldGet(this, _Interceptor_name, "f");
    }
    get $alias() {
        return __classPrivateFieldGet(this, _Interceptor_alias, "f");
    }
    get $check() {
        return __classPrivateFieldGet(this, _Interceptor_check, "f");
    }
    get $handler() {
        return __classPrivateFieldGet(this, _Interceptor_handler, "f");
    }
    get $usage() {
        return __classPrivateFieldGet(this, _Interceptor_usage, "f");
    }
    $attributes(context, ...args) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = {};
            for (const a in __classPrivateFieldGet(this, _Interceptor_attributes, "f")) {
                const attr = __classPrivateFieldGet(this, _Interceptor_attributes, "f")[a];
                result[a] = {
                    desc: attr.desc,
                    data: (typeof attr.handler === "function") ? yield attr.handler(context, ...args) : attr.handler
                };
            }
            return result;
        });
    }
    title(title) {
        if (!__classPrivateFieldGet(this, _Interceptor_alias, "f").includes(title) && __classPrivateFieldGet(this, _Interceptor_name, "f") !== title)
            __classPrivateFieldSet(this, _Interceptor_title, title, "f");
        return this;
    }
    alias(alias) {
        if (!__classPrivateFieldGet(this, _Interceptor_alias, "f").includes(alias) && __classPrivateFieldGet(this, _Interceptor_name, "f") !== alias && __classPrivateFieldGet(this, _Interceptor_title, "f") !== alias)
            __classPrivateFieldGet(this, _Interceptor_alias, "f").push(alias);
        return this;
    }
    check(checker, append) {
        if (append)
            __classPrivateFieldGet(this, _Interceptor_check, "f").unshift(checker);
        else
            __classPrivateFieldGet(this, _Interceptor_check, "f").push(checker);
        return this;
    }
    /**
     *
     * @param handler 用于处理事件的函数
     * @param append 是否将该函数前置，提供true将会把函数插入到队列最前方，否则插入到最后方
     */
    handler(handler, append) {
        if (append)
            __classPrivateFieldGet(this, _Interceptor_handler, "f").unshift(handler);
        else
            __classPrivateFieldGet(this, _Interceptor_handler, "f").push(handler);
        return this;
    }
    usage(usage) {
        __classPrivateFieldSet(this, _Interceptor_usage, usage, "f");
        return this;
    }
    attribute(name, attribute, desc) {
        __classPrivateFieldGet(this, _Interceptor_attributes, "f")[name] = {
            desc, handler: attribute
        };
        return this;
    }
}
exports.default = Interceptor;
_Interceptor_name = new WeakMap(), _Interceptor_registHandler = new WeakMap(), _Interceptor_title = new WeakMap(), _Interceptor_alias = new WeakMap(), _Interceptor_check = new WeakMap(), _Interceptor_handler = new WeakMap(), _Interceptor_usage = new WeakMap(), _Interceptor_attributes = new WeakMap();
