"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mp = void 0;
const MessageProcessor_1 = require("../lib/MessageProcessor");
const bot_1 = require("../bot");
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
const Context_1 = __importDefault(require("../lib/Context"));
const Util_1 = require("../lib/Util");
const context = new Context_1.default({
    bot: bot_1.wechaty,
    sqliteTemplate: bot_1.sqliteTemplate,
    template: bot_1.template,
    callLimiter: bot_1.callLimiter,
    __data_dir: bot_1.__data_dir,
    __src_dir: bot_1.__src_dir,
    __build_dir: bot_1.__build_dir,
    __interceptor_dir: bot_1.__interceptor_dir
});
const mp = new MessageProcessor_1.MessageProcessor(context);
exports.mp = mp;
mp.on("error", (message, error) => {
    if (error.message === "ERR_CANNOT_GET_KEY")
        return context.template.use("error.api.key.missing");
    else if (error.message === "ERR_CALL_LIMIT")
        return context.template.use("error.api.call.limit");
    else if (error.message === "ERR_CALL_NO_PERMISSION")
        return context.template.use("error.api.call.no_permission");
    else {
        console.error(context.template.use("on.error"));
        console.error(error);
        return context.template.use("error.unknown");
    }
});
const interceptorConfig = (function () {
    try {
        return JSON.parse(fs_1.default.readFileSync(path_1.default.join(context.__data_dir, "./config/interceptor.json"), "utf-8"));
    }
    catch (_a) {
        return {};
    }
})();
const enabledInterceptorList = interceptorConfig.enable || [];
const loadInterceptor = function () {
    return __awaiter(this, void 0, void 0, function* () {
        let count = 0;
        for (const n of enabledInterceptorList) {
            const interceptor = yield (function () {
                return __awaiter(this, void 0, void 0, function* () {
                    try {
                        if (Util_1.isAbsolute(n))
                            return (yield Promise.resolve().then(() => __importStar(require(n)))).default;
                        else if (fs_1.default.existsSync(path_1.default.join(bot_1.__data_dir, `./interceptor/${n}`)))
                            return (yield Promise.resolve().then(() => __importStar(require(path_1.default.join(bot_1.__data_dir, `./interceptor/${n}`))))).default;
                        else if (fs_1.default.existsSync(path_1.default.join(bot_1.__data_dir, `./interceptor/${n}.js`)))
                            return (yield Promise.resolve().then(() => __importStar(require(path_1.default.join(bot_1.__data_dir, `./interceptor/${n}.js`))))).default;
                        return (yield Promise.resolve().then(() => __importStar(require(`./method/${n}`)))).default;
                    }
                    catch (e) {
                        console.warn(`Error occurred when import interceptor "${n}":`);
                        console.warn(e);
                        return null;
                    }
                });
            })();
            try {
                yield mp.interceptor(interceptor);
                count++;
            }
            catch (e) {
                console.warn(`Error occurred when regist interceptor "${n}":`);
                console.warn(e);
            }
        }
        console.log(context.template.use("on.load.finish", { count }));
    });
};
void loadInterceptor();
