"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Interceptor_1 = __importDefault(require("../../Interceptor"));
const gardenInterceptor = new Interceptor_1.default("garden")
    .title("后花园")
    .usage("查看详细的使用帮助和运行状态")
    .check((context, message) => {
    const room = message.room();
    if (!room)
        return;
    if (!/^二师兄的?后花园(在[哪那]儿?])?/.test(message.text()))
        return;
    return {
        id: room.id
    };
})
    .handler((context, message, checkerArgs) => {
    const { id } = checkerArgs;
    const { baseUrl } = Object.assign({}, context.getMethodConfig("garden"));
    return new URL(`${baseUrl}${baseUrl.endsWith("/") ? "" : "/"}${id}/status`).toString();
});
exports.default = gardenInterceptor;
