"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Interceptor_1 = __importDefault(require("../../Interceptor"));
const index_1 = require("../../index");
const helpInterceptor = new Interceptor_1.default("help")
    .title("使用帮助")
    .alias("help")
    .check((context, message) => {
    const text = message.text().replace(/^二师兄[，。,.\s]*/, "");
    if (/^二师兄(.*)?(使用帮助|怎么用|有(哪些|那些|什么|啥)功能)$/.test(message.text().toLowerCase()))
        return true;
    else if (/(.*)怎么[用玩看找搜]/.test(text))
        return {
            method: /(.*)怎么[用玩看找搜]/.exec(text)[1]
        };
})
    .handler((context, message, checkerArgs) => __awaiter(void 0, void 0, void 0, function* () {
    if (checkerArgs.method) {
        const usage = yield index_1.mp.usage(checkerArgs.method, message);
        if (usage)
            return usage;
    }
    else {
        const usages = yield index_1.mp.usages(message);
        return usages.join("<br/>");
    }
}))
    .usage("获取二师兄的使用帮助");
exports.default = helpInterceptor;
