"use strict";
/**
 * 讲笑话功能
 * 本文件提供讲笑话的实现，默认提供的是 聚合数据 API的实现。
 * 如果需要自己扩展实现，可以参照默认实现编写函数。
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const juheapi_1 = __importDefault(require("./juheapi"));
const Interceptor_1 = __importDefault(require("../../Interceptor"));
const jokeInterceptor = new Interceptor_1.default("joke", context => {
    context.template.add("joke.success", [
        "好嘞，给您讲个笑话图一乐：<br/>{content}",
        "笑话来咯：<br/>{content}",
        "行，给老板讲个段子：<br/>{content}"
    ]);
    context.template.add("joke.failed", "哎呀，二师兄没找到合适的笑话。等会再来试试？");
})
    .title("讲笑话")
    .alias("笑话")
    .alias("讲段子")
    .alias("段子")
    .usage("讲个笑话吧")
    .check((context, message) => /^(二师兄.*)讲个?(笑话|段子)/.test(message.text()))
    .handler((context) => __awaiter(void 0, void 0, void 0, function* () {
    const result = yield juheapi_1.default();
    if (result && result.length > 0) {
        return context.template.use("joke.success", {
            content: result
        });
    }
    else {
        return context.template.use("joke.failed");
    }
}));
exports.default = jokeInterceptor;
