"use strict";
/**
 * 天气查询 彩云实现
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toAqiDesc = exports.coldRiskDict = exports.dressingDict = exports.ultravioletDict = exports.skyconDict = void 0;
const CaiyunAPI_1 = require("../../../lib/APIs/CaiyunAPI");
const axios_1 = __importDefault(require("axios"));
const bot_1 = require("../../../bot");
const axios = axios_1.default.create();
exports.skyconDict = {
    CLEAR_DAY: "晴（白天）",
    CLEAR_NIGHT: "晴（夜间）",
    PARTLY_CLOUDY_DAY: "多云（白天）",
    PARTLY_CLOUDY_NIGHT: "多云（夜间）",
    CLOUDY: "阴",
    LIGHT_HAZE: "轻度雾霾",
    MODERATE_HAZE: "中度雾霾",
    HEAVY_HAZE: "重度雾霾",
    LIGHT_RAIN: "小雨",
    MODERATE_RAIN: "中雨",
    HEAVY_RAIN: "大雨",
    STORM_RAIN: "暴雨",
    FOG: "雾",
    LIGHT_SNOW: "小雪",
    MODERATE_SNOW: "中雪",
    HEAVY_SNOW: "大雪",
    STORM_SNOW: "暴雪",
    DUST: "浮尘",
    SAND: "沙尘",
    WIND: "大风"
};
exports.ultravioletDict = ["无", "很弱", "很弱", "弱", "弱", "中等", "中等", "强", "强", "很强", "很强", "极强"];
exports.dressingDict = ["极热", "极热", "很热", "热", "温暖", "凉爽", "冷", "寒冷", "极冷"];
exports.coldRiskDict = [null, "少发", "较易发", "易发", "极易发"];
const toAqiDesc = (aqi) => {
    if (aqi <= 50)
        return "优";
    else if (aqi <= 100)
        return "良";
    else if (aqi <= 200)
        return "轻度污染";
    else if (aqi <= 300)
        return "中度污染";
    else
        return "重度污染";
};
exports.toAqiDesc = toAqiDesc;
bot_1.template.set("weather.success", "{address}的实时天气情况：<br/>{weather}<br/>温度：{temperature}℃<br/>体感温度：{apparent_temperature}℃<br/>空气质量：{aqi}<br/>舒适指数：{comfort}<br/>紫外线指数：{ultraviolet}<br/>以上数据来源于彩云天气");
function caiyunWeather(lng, lat) {
    const apiKey = CaiyunAPI_1.getAPIKey("weather");
    return new Promise((resolve, reject) => {
        axios({
            method: "GET",
            url: `https://api.caiyunapp.com/v2.5/${apiKey}/${lng},${lat}/realtime.json`,
            params: {
                lang: "zh-CN",
                unit: "metric"
            }
        }).then((value) => {
            const data = value.data;
            if (data.status === "ok")
                resolve(data);
            else
                reject(data.error);
        }).catch(reject);
    });
}
exports.default = caiyunWeather;
