"use strict";
/*
查天气功能
本文件提供查天气功能的实现，默认提供的是 彩云天气 API实现。
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// 将具体实现引用放在后面，就可以在该引用文件里使用 template.set 来修改默认的返回值
const caiyunapi_1 = __importStar(require("./caiyunapi"));
const CaiyunAPI_1 = require("../../../lib/APIs/CaiyunAPI");
const Interceptor_1 = __importDefault(require("../../Interceptor"));
const weatherInterceptor = new Interceptor_1.default("weather", context => {
    context.template.add("weather.location.unknown", "二师兄不知道你说的是哪里，确认一下？");
    context.template.add("weather.success", "{address}的天气情况：<br/>{weather}<br/>温度：{temperature}");
})
    .title("查天气")
    .alias("天气")
    .usage("二师兄，xx天气如何？")
    .check((context, message) => {
    if (/^二师兄/.test(message.text()) && (/查(.*)的?天气/.test(message.text()) || /(.*)的?天气(如何|怎么?样)/.test(message.text()))) {
        const text = message.text().replace(/^二师兄[，。,.\s]*/, "");
        const matchArg = () => {
            if (text.match(/查(.*)的?天气/))
                return text.match(/查(.*)的?天气/)[1];
            else if (text.match(/(.*)的?天气(如何|怎么?样)/))
                return text.match(/(.*)的?天气(如何|怎么?样)/)[1];
            else
                return undefined;
        };
        const arg = matchArg();
        return { arg };
    }
})
    .handler((context, message, checkerArgs) => __awaiter(void 0, void 0, void 0, function* () {
    const { arg } = checkerArgs;
    if (!arg)
        return context.template.use("weather.location.unknown");
    else {
        const location = yield CaiyunAPI_1.place(arg);
        const data = yield caiyunapi_1.default(location.location.lng, location.location.lat);
        return context.template.use("weather.success", {
            address: `${location.name}（${location.address}）`,
            weather: caiyunapi_1.skyconDict[data.result.realtime.skycon],
            temperature: data.result.realtime.temperature,
            apparent_temperature: data.result.realtime.apparent_temperature,
            aqi: `${data.result.realtime.air_quality.aqi.chn}（${caiyunapi_1.toAqiDesc(data.result.realtime.air_quality.aqi.chn)}）`,
            comfort: `${data.result.realtime.life_index.comfort.index}（${caiyunapi_1.dressingDict[data.result.realtime.life_index.comfort.index]}）`,
            ultraviolet: `${data.result.realtime.life_index.ultraviolet.index}（${caiyunapi_1.ultravioletDict[data.result.realtime.life_index.ultraviolet.index]}）`
        });
    }
}));
exports.default = weatherInterceptor;
