"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * 热搜查询
 * 提供新浪微博实时热搜查询，默认提供的是挖数据（wapi）和天行数据（TianAPI）的实现。
 */
const Emoji = require("node-emoji");
// 默认使用WAPI查询。如果需要自定义查询实现，请参照WAPI实现或TianAPI实现编写。
const wapi_1 = __importDefault(require("./wapi"));
const Interceptor_1 = __importDefault(require("../../Interceptor"));
// import TianAPIWeiboHot from "./tianapi"
const weiboInterceptor = new Interceptor_1.default("weibo", context => {
    context.template.add("weibo.success", [
        "微博热搜有哪些：<br/>{hotSearch}",
        "现在的微博热搜：<br/>{hotSearch}",
    ]);
})
    .title("微博热搜")
    .alias("看热搜")
    .alias("查热搜")
    .alias("热搜")
    .usage("查看最新最热的微博爆款热搜")
    .check((context, message) => {
    if (/^二师兄/.test(message.text()) && /[查看有]?(微博)?热搜/.test(message.text()))
        return true;
}).handler((context) => __awaiter(void 0, void 0, void 0, function* () {
    const hotSearchList = yield wapi_1.default();
    // const hotSearchList = await TianAPIWeiboHot()
    return context.template.use("weibo.success", {
        hotSearch: hotSearchList
            .map(h => `${h.key}${h.isNew ? Emoji.get("new") : ""}${h.isHot ? Emoji.get("fire") : ""}${h.isExplosive ? Emoji.get("boom") : ""}${h.isBoiled ? Emoji.get("hotsprings") : ""}`)
            .join("<br/>")
    });
}));
exports.default = weiboInterceptor;
