"use strict";
/**
 * 热搜查询 TianAPI实现
 * 关于 TianAPI 的密钥申请与配置，请参考 /docs 文件夹下的 TianAPI.md
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const TianAPI_1 = require("../../../lib/APIs/TianAPI");
const axios = axios_1.default.create();
function weiboHot() {
    const key = TianAPI_1.getKey();
    return new Promise((resolve, reject) => {
        axios({
            method: "GET",
            url: "http://api.tianapi.com/txapi/weibohot/index",
            params: { key }
        }).then((value) => {
            if (value.data.code === 200) {
                // Tian API 返回的是50条微博热搜，但是没有标注“热”、“爆”、“沸”等标签。
                // 可以根据需要自己对返回值做调整。这里默认只返回前十的热搜。
                const result = value.data.newslist.map(k => {
                    return {
                        key: k.hotword,
                        hot: k.hotwordnum
                    };
                });
                resolve(result.slice(0, 10));
            }
            else if (value.data.code === 150)
                reject("ERR_CALL_LIMIT");
            else if (value.data.code === 160)
                reject("ERR_CALL_NO_PERMISSION");
            else if (value.data.code)
                reject(value.data.code);
            else
                reject();
        }).catch(reject);
    });
}
exports.default = weiboHot;
