"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * 热搜查询 WAPI实现
 * 偷偷讲：这个API是从公开页面上扒下来的，属于白嫖行为，不知道能坚持多久
 */
const axios_1 = __importDefault(require("axios"));
const axios = axios_1.default.create();
function hotSearch() {
    return new Promise((resolve, reject) => {
        axios({
            method: "POST",
            url: "https://www.wapi.cn/other/hot_search",
            headers: {
                "Content-Type": "application/x-www-form-urlencoded"
            },
            data: `r=${Math.random()}&t=1hour&keyword=`
        }).then((value) => {
            if (value.data.codeid === 10000) {
                const hotSearchList = value.data.retdata;
                const latestHotSearch = hotSearchList[hotSearchList.length - 1];
                latestHotSearch.sort((a, b) => b.w_hot - a.w_hot);
                resolve(latestHotSearch.map(h => {
                    return {
                        key: h.w_key,
                        hot: h.w_hot,
                        isHot: h.w_label.includes("热"),
                        isExplosive: h.w_label.includes("爆"),
                        isBoiled: h.w_label.includes("沸"),
                        isNew: h.w_label.includes("新")
                    };
                }));
            }
            else if (value.data.codeid === 10010)
                reject("ERR_CALL_NO_PERMISSION");
            else if (value.data.codeid === 10018)
                reject("ERR_CALL_LIMIT");
            else
                reject(value.data.message);
        }).catch(reject);
    });
}
exports.default = hotSearch;
