"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKey = void 0;
const fs_1 = __importDefault(require("fs"));
const bot_1 = require("../../bot");
const path_1 = __importDefault(require("path"));
function getKey() {
    try {
        const data = fs_1.default.readFileSync(path_1.default.join(bot_1.__data_dir, "./api/tianapi.json"), "utf-8");
        const dataParsed = JSON.parse(data);
        if (!dataParsed.key)
            throw new Error("Property \"key\" not defined");
        if (typeof dataParsed.key !== "string")
            throw new Error("Property \"key\" is not string");
        return dataParsed.key;
    }
    catch (e) {
        console.error("获取 TianAPI 的密钥时出错");
        console.error(e);
        throw new Error("ERR_CANNOT_GET_KEY");
    }
}
exports.getKey = getKey;
