"use strict";
/*
9月17日追加：
    考虑到先行的拦截器耦合度依旧很高，这里引入一个“上下文”的概念。
    “上下文”在载入插件前就创建完毕，包含模板、数据库操作类、调用计数器、机器人实例等。
    这样做就允许开发者单独去开发一个插件，而不是fork仓库后再去开发插件。
*/
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
class Context {
    constructor(mem) {
        this.bot = mem.bot;
        this.sqliteTemplate = mem.sqliteTemplate;
        this.template = mem.template;
        this.callLimiter = mem.callLimiter;
        this.__data_dir = mem.__data_dir;
        this.__interceptor_dir = mem.__interceptor_dir;
        this.__build_dir = mem.__build_dir;
        this.__src_dir = mem.__src_dir;
    }
    getMethodConfig(name) {
        try {
            const configPath = path_1.default.join(this.__data_dir, `config/method/${name}.json`);
            if (fs_1.default.existsSync(configPath)) {
                const fileData = fs_1.default.readFileSync(configPath, "utf-8");
                return JSON.parse(fileData);
            }
        }
        catch (_a) {
            // Do nothing
        }
        return {};
    }
}
exports.default = Context;
