"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAbsolute = exports.mkdirSync = void 0;
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
function mkdirSync(dirPath) {
    if (dirPath === null || dirPath === "")
        return;
    dirPath = isAbsolute(dirPath) ? path_1.default.normalize(dirPath) : path_1.default.join(process.cwd(), dirPath);
    if (fs_1.default.existsSync(dirPath))
        return;
    const arr = dirPath.split(path_1.default.sep);
    let index = arr.length - 1;
    let tempStr = arr[index];
    while (tempStr === "" && arr.length > 0) {
        index--;
        tempStr = arr[index];
    }
    if (tempStr === "")
        return;
    const newPath = dirPath.substring(0, dirPath.length - tempStr.length - 1);
    if (!fs_1.default.existsSync(newPath))
        mkdirSync(newPath);
    fs_1.default.mkdirSync(dirPath);
}
exports.mkdirSync = mkdirSync;
function isAbsolute(filePath) {
    filePath = path_1.default.normalize(filePath);
    if (filePath.substring(0, 1) === "/")
        return true;
    return filePath.search(/[\w]+:/) === 0;
}
exports.isAbsolute = isAbsolute;
