"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ResponseGenerator_1 = require("../../ResponseGenerator");
const bot_1 = require("../../../bot");
const interceptor_1 = require("../../../interceptor");
const parse = (str) => {
    try {
        return JSON.parse(str);
    }
    catch (_a) {
        return null;
    }
};
const handler = (req, res, data) => __awaiter(void 0, void 0, void 0, function* () {
    const args = data ? parse(typeof data === "string" ? data : data.toString("utf-8")) : {};
    const userSelf = (() => {
        try {
            return bot_1.wechaty.userSelf();
        }
        catch (_a) {
            return null;
        }
    })();
    return ResponseGenerator_1.success({
        isLogin: !!userSelf,
        name: userSelf ? userSelf.name() : null,
        avatar: userSelf ? `data:image/png;base64,${yield (yield userSelf.avatar()).toBase64()}` : null,
        startAt: bot_1.startAt,
        mem: process.memoryUsage(),
        attributes: yield interceptor_1.mp.attributes(args)
    });
});
exports.default = handler;
