"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ResponseGenerator_1 = require("../../ResponseGenerator");
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const bot_1 = require("../../../bot");
const interceptor_1 = require("../../../interceptor");
const parse = (str) => {
    try {
        return JSON.parse(str);
    }
    catch (_a) {
        return null;
    }
};
const handler = (req, res, data) => {
    if (!data)
        return ResponseGenerator_1.success(interceptor_1.mp.list());
    const params = parse(typeof data === "string" ? data : data.toString("utf-8"));
    if (!params)
        return ResponseGenerator_1.error("ERR_PARAM_INVALID");
    const { name } = params;
    if (!name)
        return ResponseGenerator_1.error("ERR_PARAM_INVALID");
    const fileBuildDir = path_1.default.join(bot_1.__interceptor_dir, `./method/${name}`);
    const fileSrcDir = fileBuildDir.replace(bot_1.__build_dir, bot_1.__src_dir);
    if (!fs_1.default.existsSync(fileBuildDir))
        return ResponseGenerator_1.error("ERR_METHOD_NOT_EXISTS");
    const fileBuildPath = path_1.default.join(fileBuildDir, "./README.md");
    if (fs_1.default.existsSync(fileBuildPath))
        return ResponseGenerator_1.success(fs_1.default.readFileSync(fileBuildPath, "utf-8"));
    const fileSrcPath = path_1.default.join(fileSrcDir, "./README.md");
    if (fs_1.default.existsSync(fileSrcPath))
        return ResponseGenerator_1.success(fs_1.default.readFileSync(fileSrcPath, "utf-8"));
    return ResponseGenerator_1.success("");
};
exports.default = handler;
