"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_1 = __importDefault(require("http"));
const router_1 = __importDefault(require("./router"));
const statics_1 = __importDefault(require("./statics"));
const staticExp = /\/public\/(img|css|js)\/[a-z]*\.(jpg|png|gif|webp|css|js)/;
function default_1(port = 8088) {
    http_1.default.createServer((req, res) => __awaiter(this, void 0, void 0, function* () {
        const pathname = req.url;
        if (staticExp.test(pathname))
            statics_1.default.get(pathname, res);
        else if (req.method.toUpperCase() === "POST")
            yield router_1.default.post(req, res);
        else if (req.method.toUpperCase() === "GET")
            yield router_1.default.get(req, res);
        else {
            res.statusCode = 405;
            res.end();
        }
    })).listen(port);
    console.log("[Server]", `Backend server started at http://0.0.0.0:${port}`);
}
exports.default = default_1;
