"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const routes_1 = __importDefault(require("./routes"));
class Router {
    static get(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            res.setHeader("Content-Type", "application/json; charset=utf-8");
            const pathname = req.url;
            for (const route of routes_1.default) {
                if (route.path === pathname) {
                    if (route.method && !route.method.split(",").map(m => m.toUpperCase()).includes("GET")) {
                        res.writeHead(405);
                        res.end();
                        return;
                    }
                    const result = yield route.handler(req, res);
                    if (result)
                        res.end(result);
                    break;
                }
            }
        });
    }
    static post(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            res.setHeader("Content-Type", "application/json; charset=utf-8");
            const pathname = req.url;
            for (const route of routes_1.default) {
                if (route.method && !route.method.split(",").map(m => m.toUpperCase()).includes("POST")) {
                    res.writeHead(405);
                    res.end();
                    return;
                }
                if (route.path === pathname) {
                    let data;
                    req.on("data", function (chunk) {
                        if (!data)
                            data = chunk;
                        else
                            data += chunk;
                    });
                    req.on("end", function () {
                        return __awaiter(this, void 0, void 0, function* () {
                            const result = yield route.handler(req, res, data);
                            if (result)
                                res.end(result);
                        });
                    });
                    break;
                }
            }
        });
    }
}
exports.default = Router;
